#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os , math, bs4, logging
from PIL import Image, ImageDraw, ImageFont
from pandas import DataFrame, read_excel
import mplfinance as mpf
import requests, json, random, threading
import datetime
import time
import openpyxl
import fitz
import patoolib
from random import randint
from BotData import Local, MainPath
import warnings
warnings.filterwarnings( "ignore", module = "matplotlib\..*" )

if not Local:
    os.environ["IMAGEIO_FFMPEG_EXE"] = "/usr/bin/ffmpeg"

from moviepy.editor import VideoFileClip

def Error_decorator(func):
    def function(*args, **kwargs):
        try:
            return func(*args, **kwargs)
        except Exception as e:
            print(func.__name__, 'Exception: ', str(e)) if Local else None
            logging.error(func.__name__, 'Exception: ', str(e))
    return function

@Error_decorator
def deposit_address(coin):
    wallets = {'BTC': '1AHwUT4JP1JQuQz7AVnTs4Rb8Tk1Y5WqTa',
     'ETH': '0x12315b2bc6b3811166c42b094e46126e06db4c93',
     'XRP': 'rEb8TK3gBgk5auZkwc6sHnwrGVJH8DuaLh',
     'LINK': '0x12315b2bc6b3811166c42b094e46126e06db4c93',
     'LTC': 'LZkGuwxnDoChcMKJkQYmNw6F9uMTWbruMY',
     'BCH': '1AHwUT4JP1JQuQz7AVnTs4Rb8Tk1Y5WqTa',
     'DOT': '13bnUbmkPKxVh8bfNu8rqe3zeoyUEZWbYbjV6R5xagvTis6J',
     'ADA': 'DdzFFzCqrhtBR7UjGVNbZtDjiQyXVj7fxUhGE4zim1vZvX9Hffd6ttk1BgfkbE4P37Qb52cC7wEuDw1ACw4gYSgrRnLWyYbgLZn9GSQF',
     'BNB': 'bnb136ns6lfw4zs5hg4n85vdthaad7hq5m4gtkgf23',
     'USDT': '0x12315b2bc6b3811166c42b094e46126e06db4c93'}
    return wallets.get(coin, 'Not Available')

@Error_decorator
def get_coin_price(coin):
    response=requests.get('https://api.binance.com/api/v3/ticker/price?symbol={}USDT'.format(coin))
    price_dict = json.loads(response.text)
    price = round(float(price_dict['price']),2)
    res = 'symbol :'+price_dict['symbol']+'         price :'+str(price)+ ' $'
    return res

lst = []
@Error_decorator
def coin_price(coin, i):
    response=requests.get('https://api.binance.com/api/v3/ticker/price?symbol={}USDT'.format(coin))
    price_dict = json.loads(response.text)
    price=round(float(price_dict['price']),2)
    global lst
    txt = '%.2d' %(i) +'- symbol :'+price_dict['symbol']+'\t\t price :'+str(price)+ ' $\n' 
    lst.append(txt)

@Error_decorator
def Threaded_download():
    coin_list = ['BTC','ETH','ADA','BNB','XRP','DOGE','DOT','UNI','LTC','BCH']
    DownloadThreads = []
    i = 1
    for coin in coin_list:
        DownloadThread = threading.Thread(target=coin_price, args=(coin,i))
        DownloadThreads.append(DownloadThread)
        DownloadThread.start()
        i += 1
    for DownloadThread in DownloadThreads:
        DownloadThread.join()
    global lst
    lst.sort()
    text = ''
    for item in lst:
        text += item
    lst = []
    return text

@Error_decorator
def Add_Watermark(im, text='Https://t.me/HandyToolsBot', position=3):
    try:
        width, height = im.size
        draw = ImageDraw.Draw(im)
        if Local:
            font = ImageFont.truetype('times.ttf', 16)
        else:
            font = ImageFont.truetype('LiberationMono-Regular.ttf', 16)
        textwidth, textheight = draw.textsize(text, font)
        margin = 7
        if position == 4:
            x = width - textwidth - margin
            y = height - textheight - margin
        elif position == 3:
            x = margin
            y = height - textheight - margin
        draw.text((x, y), text, font=font)
    except:
        return False

@Error_decorator
def reduse_image_size(file, final_size, watermark=True):
    ''' This function can reduce or even increase pictures size, \
        input size in KiloBytes'''
    current_size=os.stat(file).st_size
    final_size*=920
    im=Image.open(file)
    try:
        image_exif = im.getexif()
        image_orientation = image_exif[274]
        if image_orientation in (2,'2'):
            im = im.transpose(Image.FLIP_LEFT_RIGHT)
        elif image_orientation in (3,'3'):
            im = im.transpose(Image.ROTATE_180)
        elif image_orientation in (4,'4'):
            im = im.transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (5,'5'):
            im = im.transpose(Image.ROTATE_90).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (6,'6'):
            im = im.transpose(Image.ROTATE_270)
        elif image_orientation in (7,'7'):
            im = im.transpose(Image.ROTATE_270).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (8,'8'):
            im = im.transpose(Image.ROTATE_90)
        else:
            pass
    except:
        pass
    width, height= im.size
    factor=math.sqrt(current_size/final_size)
    new_name = f'{os.path.splitext(file)[0]}-Reduced{os.path.splitext(file)[1]}'
    new_width, new_height=int(width/factor) , int(height/factor)
    reduced_img=im.resize(( new_width, new_height))
    if watermark:
        Add_Watermark(im)
    reduced_img.save(new_name)
    reduced_img.close()
    i = 0
    while  (os.stat(new_name).st_size < 0.7*final_size and  i<3 ) or os.stat(new_name).st_size > final_size  : 
        if os.stat(new_name).st_size > final_size:
            factor += 0.2
            new_width, new_height=int(width/factor) , int(height/factor)
            reduced_img=im.resize(( new_width, new_height))
            if watermark:
                Add_Watermark(im)
            reduced_img.save(new_name)
            reduced_img.close()
            i+=1
        elif os.stat(new_name).st_size < 0.7*final_size:
            factor -= 0.2
            new_width, new_height=int(width/factor) , int(height/factor)
            reduced_img=im.resize(( new_width, new_height))
            if watermark:
                Add_Watermark(im)
            reduced_img.save(new_name)
            reduced_img.close()
            i+=1
    return new_name

@Error_decorator
def reduse_image_pixel_size(file, factor=2, watermark=True):
    ''' This function can reduce pictures size four times as original'''
    im=Image.open(file)
    try:
        image_exif = im.getexif()
        image_orientation = image_exif[274]
        if image_orientation in (2,'2'):
            im = im.transpose(Image.FLIP_LEFT_RIGHT)
        elif image_orientation in (3,'3'):
            im = im.transpose(Image.ROTATE_180)
        elif image_orientation in (4,'4'):
            im = im.transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (5,'5'):
            im = im.transpose(Image.ROTATE_90).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (6,'6'):
            im = im.transpose(Image.ROTATE_270)
        elif image_orientation in (7,'7'):
            im = im.transpose(Image.ROTATE_270).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (8,'8'):
            im = im.transpose(Image.ROTATE_90)
        else:
            pass
    except:
        pass
    new_name = f'{os.path.splitext(file)[0]}-Reduced{os.path.splitext(file)[1]}'
    width, height = im.size
    reduced_img=im.resize(( width//factor, height//factor))
    if watermark:
        Add_Watermark(im)
    reduced_img.save(new_name)
    reduced_img.close()
    return new_name

@Error_decorator
def convert_image_to_PDF(file, watermark=True):
    image=Image.open(file)
    im=image.convert('RGB')
    try:
        image_exif = im.getexif()
        image_orientation = image_exif[274]
        if image_orientation in (2,'2'):
            im = im.transpose(Image.FLIP_LEFT_RIGHT)
        elif image_orientation in (3,'3'):
            im = im.transpose(Image.ROTATE_180)
        elif image_orientation in (4,'4'):
            im = im.transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (5,'5'):
            im = im.transpose(Image.ROTATE_90).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (6,'6'):
            im = im.transpose(Image.ROTATE_270)
        elif image_orientation in (7,'7'):
            im = im.transpose(Image.ROTATE_270).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (8,'8'):
            im = im.transpose(Image.ROTATE_90)
        else:
            pass
    except:
        pass
    filename='{}.pdf'.format(os.path.splitext(file)[0])
    if watermark:
        Add_Watermark(im)
    im.save(filename)
    im.close()
    return filename

@Error_decorator
def convert_image_to_PDF_2(file):
    #Little bit Slower Than Original Function But Return Full Resolution Image
    res = fitz.open()
    img = fitz.open(file)
    pdfbytes = img.convertToPDF()
    imgPDF = fitz.open("pdf", pdfbytes)
    res.insertPDF(imgPDF)
    filename='{}.pdf'.format(os.path.splitext(file)[0])
    res.save (filename)
    res.close()
    return filename

@Error_decorator
def convert_multi_image_to_PDF(lst, FinalName, watermark=True):
    imagelist = []
    i = 1
    for file in lst[1:]:
        image=Image.open(file)
        im=image.convert('RGB')
        try:
            image_exif = im.getexif()
            image_orientation = image_exif[274]
            if image_orientation in (2,'2'):
                im = im.transpose(Image.FLIP_LEFT_RIGHT)
            elif image_orientation in (3,'3'):
                im = im.transpose(Image.ROTATE_180)
            elif image_orientation in (4,'4'):
                im = im.transpose(Image.FLIP_TOP_BOTTOM)
            elif image_orientation in (5,'5'):
                im = im.transpose(Image.ROTATE_90).transpose(Image.FLIP_TOP_BOTTOM)
            elif image_orientation in (6,'6'):
                im = im.transpose(Image.ROTATE_270)
            elif image_orientation in (7,'7'):
                im = im.transpose(Image.ROTATE_270).transpose(Image.FLIP_TOP_BOTTOM)
            elif image_orientation in (8,'8'):
                im = im.transpose(Image.ROTATE_90)
            else:
                pass
        except:
            pass
        if watermark:
            Add_Watermark(im)
        imagelist.append(im)
        i += 1
    im1 = Image.open (lst[0])
    try:
        image_exif = im1.getexif()
        image_orientation = image_exif[274]
        if image_orientation in (2,'2'):
            im1 = im1.transpose(Image.FLIP_LEFT_RIGHT)
        elif image_orientation in (3,'3'):
            im1 = im1.transpose(Image.ROTATE_180)
        elif image_orientation in (4,'4'):
            im1 = im1.transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (5,'5'):
            im1 = im1.transpose(Image.ROTATE_90).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (6,'6'):
            im1 = im1.transpose(Image.ROTATE_270)
        elif image_orientation in (7,'7'):
            im1 = im1.transpose(Image.ROTATE_270).transpose(Image.FLIP_TOP_BOTTOM)
        elif image_orientation in (8,'8'):
            im1 = im1.im1transpose(Image.ROTATE_90)
        else:
            pass
    except:
        pass
    filename = '{}.pdf'.format(os.path.splitext(FinalName)[0])
    if watermark:
        Add_Watermark(im1)
    im1.save(filename,save_all=True, append_images=imagelist)
    im1.close()
    return filename

@Error_decorator
def Audio_Time_Estimate(file):
    video = VideoFileClip(file)
    return str(video.duration)

@Error_decorator
def SoundSplit(file):
    video = VideoFileClip(file)
    res_file = '{}.mp3'.format(os.path.splitext(file)[0])
    video.audio.write_audiofile(res_file)
    return res_file

@Error_decorator
def get_random_joke():
    Firstname='Donald'
    Lastname='Trump'
    url='http://api.icndb.com/jokes/random?firstName={}&lastName={}&exclude=[explicit]'.format(Firstname,Lastname)
    res=requests.get(url)
    res.raise_for_status()
    data=json.loads(res.text)
    return (data['value']['joke'])

@Error_decorator
def Currency_rates():
    url = "https://www.tgju.org/currency"
    res = requests.get(url)
    res.raise_for_status()
    soup = bs4.BeautifulSoup(res.text , "html.parser")
    text = []
    for i in range(1,17):
        curr = soup.select(f"table.market-section-right:nth-child(1) > tbody:nth-child(2) > tr:nth-child({i}) > th:nth-child(1)")
        nerkh = soup.select(f"table.market-section-right:nth-child(1) > tbody:nth-child(2) > tr:nth-child({i}) > td:nth-child(2)")
        rate = nerkh[0].getText()
        symbl = curr[0].getText()
        text.append(f"{symbl} = {rate} ريال ")
    text.append("Source: tgju.org \n")
    return '\n'.join(text)

@Error_decorator
def weather_daily(city):
    API_key='b4cc42791c5a4c0e898144148201110'
    url='http://api.weatherapi.com/v1/forecast.json?key={}&q={}&days=10'.format(API_key,city)
    res=requests.get(url)
    res.raise_for_status()
    data=json.loads(res.text)
    text_forecast = []
    for i in range(len(data['forecast']['forecastday'])):
        s1=datetime.datetime.fromtimestamp(data['forecast']['forecastday'][i]['date_epoch']).strftime('%A')
        s2=data['forecast']['forecastday'][i]['day']['condition']['text']
        s3=(round(float(data['forecast']['forecastday'][i]['day']['avgtemp_c']),1))
        s4='C'
        text_forecast.append(' %s \t %s \t\t %.1f %s'%(s1,s2,s3,s4))
        
    return '\n'.join(text_forecast)

@Error_decorator
def weather_current(city):
    API_key='b4cc42791c5a4c0e898144148201110'
    url='http://api.weatherapi.com/v1/forecast.json?key={}&q={}'.format(API_key,city)
    res=requests.get(url)
    res.raise_for_status()
    data=json.loads(res.text)
    current_weather_desc=data['current']['condition']['text']
    current_weather_temp=str(round(float((data['current']['temp_c'])),1))+ ' C'
    current_weather_humidity=str(data['current']['humidity'])+'%'
    sunrise=(data['forecast']['forecastday'][0]['astro']['sunrise'])
    sunset=(data['forecast']['forecastday'][0]['astro']['sunset'])
    wind_speed=str(data['current']['wind_kph'])+' Km/h'

    text=('current weather: {}\n\
Current Temprature: {}\n\
Current Humidity: {}\n\
Sunrise: {}\n\
Sunset: {}\n\
Wind Speed: {}\n').format(current_weather_desc,current_weather_temp,current_weather_humidity,\
    sunrise,sunset,wind_speed)

    return text

@Error_decorator
def Get_random_comic():
    num=random.randint(1,2542)
    url='https://xkcd.com/{}/'.format(num)
    res=requests.get(url)
    res.raise_for_status()
    soup=bs4.BeautifulSoup(res.text,'html.parser')
    comicElem=soup.select('#comic img')
    comicUrl='https:'+comicElem[0].get('src')
    res=requests.get(comicUrl)
    res.raise_for_status()
    file_path = os.path.join(*[MainPath,'Temp_Files',os.path.basename(comicUrl)])
    imageFile=open(file_path,'wb')
    for chunk in res.iter_content(100000):
        imageFile.write(chunk)
    imageFile.close()
    return file_path

@Error_decorator
def Secure_PDF(FileName , FinalName, quality=2, watermark=True):
    doc = fitz.open(FileName)
    mat = fitz.Matrix(quality,quality)
    res = fitz.open()
    for i, page in enumerate(doc):
        pix = doc.getPagePixmap(i, matrix=mat)
        pic_file = os.path.join(*[MainPath,'Temp_Files', 'temp-{}.jpg'.format(i)])
        pix.writeImage(pic_file)
        img = fitz.open(pic_file)
        pdfbytes = img.convertToPDF()
        imgPDF = fitz.open("pdf", pdfbytes)
        rect = img[0].rect
        page = res.newPage( width=rect.width, height=rect.height)
        page.showPDFpage(rect, imgPDF, 0)
        if watermark:
            page.insert_text((7,rect.height-27), 'Https://t.me/HandyToolsBot', fontsize=16)
        os.remove(pic_file)
    final = f'{os.path.dirname(FileName)}/{os.path.basename(FinalName)}'
    res.save (final)
    res.close()
    return final

@Error_decorator
def combine_multi_pdf(lst, watermark=True):
    res = fitz.open(lst[0])
    if watermark:
        for page in res:
            page.insert_text((7,page.rect.height-27), 'Https://t.me/HandyToolsBot', fontsize=16)
    for file in lst[1:]:
        doc = fitz.open(file)
        if watermark:
            for page in doc:
                page.insert_text((7,page.rect.height-27), 'Https://t.me/HandyToolsBot', fontsize=16)
        res.insertPDF(doc)
    res.saveIncr()
    res.close()
    return lst[0]

@Error_decorator
def Secure_Time_Estimate(FileName, compress=False):
    doc = fitz.open(FileName)
    pages = int(doc.page_count)
    if compress:
        time = pages*1.1 + randint(1,5)
    else:
        time = pages*0.7 + randint(1,5)
    doc.close()
    return str(time)

@Error_decorator
def reduce_PDF_size(FileName, FinalName, quality=2, watermark=True):
    doc = fitz.open(FileName)
    pages = int(doc.page_count)
    final = f'{os.path.dirname(FileName)}/{os.path.basename(FinalName)}'
    size_per_page = int(os.stat(FileName).st_size/pages)
    if  size_per_page > 250000:
        mat = fitz.Matrix(quality,quality)
        res = fitz.open()
        for i, page in enumerate(doc):
            pix = doc.getPagePixmap(i, matrix=mat)
            pic_file = os.path.join(*[MainPath,'Temp_Files', 'temp-{}.jpg'.format(i)])
            pix.writeImage(pic_file)
            new_pic_file = reduse_image_pixel_size(pic_file, watermark=False)
            img = fitz.open(new_pic_file)
            pdfbytes = img.convertToPDF()
            imgPDF = fitz.open("pdf", pdfbytes)
            rect = img[0].rect
            page = res.newPage( width=rect.width, height=rect.height)
            if watermark:
                page.insert_text((7,rect.height-27), 'Https://t.me/HandyToolsBot', fontsize=16)
            page.showPDFpage(rect, imgPDF, 0)
            os.remove(new_pic_file)
            os.remove(pic_file)
        res.save (final)
        res.close()
    else:
        doc.save(final)
        doc.close()
    return final

@Error_decorator
def zip_extract(FileName, FinalDir):
    return patoolib.extract_archive(FileName ,outdir=FinalDir)

@Error_decorator
def Log_to_Excel(log):
    try:
        fin = open(log, 'r')
    except UnicodeDecodeError:
        fin = open(log, 'r', encoding= 'cp1252')
    doc=fin.readlines()
    real_data = doc[:]
    data = dict()
    for index, line in enumerate (real_data):
        if line.startswith('202'):
            if  line.split(',')[2].strip() == 'INFO':
                try:
                    cid=line.split('[')[1].split(']')[0]
                    name = line.split(',')[4].split('[')[0].strip()
                    if ('/' in line) and ('CLI' not in real_data[index-1]) and ('YouTube' not in real_data[index-1]):
                        try:
                            command = line.split('/')[-1][:-1].title().strip()
                            if len(command) > 1:
                                data.setdefault(cid, {})
                                data[cid].setdefault('User_Name' ,name)
                                #data[cid]['User_Name'] = name      Activate This Line for Update Usersname Column With Latest Username
                                data[cid].setdefault(command, 0)
                                data[cid][command] += 1
                            else:
                                pass
                        except:
                            pass
                except:
                    pass
    fin.close()
    df = DataFrame(data)
    df = df.T
    df = df.fillna(0)
    df.loc["Total"] = df.sum()
    df.loc["Total", 'User_Name'] = 0
    df.loc["Total", 'User_Name']=df.loc['Total',:].sum()
    df = df.sort_values("Total" ,axis=1,ascending=False)
    date = datetime.datetime.now().strftime('%Y-%m-%d %H-%M-%S')
    file = os.path.join(*[MainPath,'Temp_Files', "{}.xlsx".format(date)])
    df.to_excel(file)
    return file

@Error_decorator
def Covid_Data(Country):
    response = requests.request("GET", "https://covid-193.p.rapidapi.com/statistics", headers={
    'x-rapidapi-key': "5836339a06msha81da3888a6f21fp1ba673jsnc2146eefc7c8",
    'x-rapidapi-host': "covid-193.p.rapidapi.com"
    })
    jsn = response.json()
    data = dict()
    for i in range(jsn['results']):
        item = jsn['response'][i]
        data[item['country']] = {
                'Active Cases': item['cases']['active'],
                'Critical' : item['cases']['critical'],
                'New Cases' : item['cases']['new'],
                'Recovered Cases' : item['cases']['recovered'],
                'Total Cases' : item['cases']['total'],
                'New Deaths' : item['deaths']['new'],
                'Total Deaths' : item['deaths']['total'],
                'Last Update' : datetime.datetime.strptime(item['time'], '%Y-%m-%dT%H:%M:%S%z').replace(tzinfo=None) + datetime.timedelta(hours=3, minutes=30)}

    df = DataFrame(data)
    df = df.T
    text = f"""Active Cases:   {df.loc[Country]['Active Cases']}\
    \nCritical:   {df.loc[Country]['Critical']}\
    \nNew Cases:   {df.loc[Country]['New Cases']}\
    \nRecovered Cases:   {df.loc[Country]['Recovered Cases']}\
    \nTotal Cases:   {df.loc[Country]['Total Cases']}\
    \nNew Deaths:   {df.loc[Country]['New Deaths']}\
    \nTotal Deaths:   {df.loc[Country]['Total Deaths']}\
    \nLast Update:   {df.loc[Country]['Last Update']}"""
    return text

@Error_decorator
def get_json_kline(symbol, interval, duration, now): 
    times={'1m':1,'3m':3,'1h':60,'2h':120,'4h':240,'6h':360,'8h':480,'12h':720,'5m':5,'15m':15,'30m':30,'1d':1440,'3d':4320,'1w':10080,'1M':44640}
    itemnu=(int(duration)*60)/times[interval]
    if itemnu>1000:
        data=[]
        endTime=int(round(time.time(),3))*1000
        length=(int(float(1000*times[interval])))*60000
        startTime=endTime - length
        url=f'https://www.binance.com/api/v3/klines?symbol={symbol}&interval={interval}&startTime={startTime}&endTime={endTime}&limit=1000'
        response=requests.get(url)
        response.raise_for_status()
        data=json.loads(response.text)

    else:
        startTime = int(round(time.time(),3)-(duration*3600))*1000
        url=f'https://www.binance.com/api/v3/klines?symbol={symbol}&interval={interval}&startTime={startTime}&limit=1000'
        response=requests.get(url)
        response.raise_for_status()
        data=json.loads(response.text)

    x=lambda a: round(float(a),3)
    wb=openpyxl.Workbook()
    sheet=wb.active
    sheet.cell(row=1, column=1).value='Row Number'
    sheet.cell(row=1, column=2).value='Open time'
    sheet.cell(row=1, column=3).value='Open'
    sheet.cell(row=1, column=4).value='High'
    sheet.cell(row=1, column=5).value='Low'
    sheet.cell(row=1, column=6).value='Close'
    sheet.cell(row=1, column=7).value='Volume(Crypto)'
    sheet.cell(row=1, column=8).value='Close time'
    sheet.cell(row=1, column=9).value='Volume(USDT)'
    sheet.cell(row=1, column=10).value='Number of trades'
    sheet.cell(row=1, column=11).value='Taker buy base asset volume'
    sheet.cell(row=1, column=12).value='Taker buy quote asset volume'
    sheet.cell(row=1, column=13).value='Ignore'
    for i in range(len(data)):
        for j in range(len(data[i])):
            sheet.cell(row=i+2, column=1).value=i+1
            sheet.cell(row=i+2, column=j+2).value=x(data[i][j])
    for i in range(len(data)):
        sheet.cell(row=i+2, column=2).value=datetime.datetime.fromtimestamp((float(data[i][0]))/1000)
        sheet.cell(row=i+2, column=8).value=datetime.datetime.fromtimestamp((float(data[i][6]))/1000)
    file_name = os.path.join(*[MainPath,'Temp_Files', "{}.xlsx".format(now)])
    wb.save(file_name)
    return file_name

@Error_decorator
def get_coin_chart(symbol, interval, duration, now):
    file_name = get_json_kline(symbol, interval, duration, now)
    df = read_excel(file_name, engine='openpyxl', parse_dates=True)
    os.remove(file_name)
    df.rename(columns={'Volume(USDT)':'Volume'}, inplace=True)
    df.set_index('Open time', inplace=True)
    res_file = os.path.join(*[MainPath,'Temp_Files', f'{symbol}-{interval}-{duration}h.png'])     
    mpf.plot(df, type='candle',  style='yahoo',mav=(3,7), volume=True, show_nontrading=True, returnfig=True, datetime_format="%b-%d %H:%M", tight_layout=True, savefig=dict(fname=res_file,dpi=400, pad_inches=0.25), warn_too_much_data=1000)
    return res_file

@Error_decorator
def Get_ip_info():
    try :
        res=requests.get('https://www.whatismyip.org/my-ip-address')
        soup=bs4.BeautifulSoup(res.text, "html.parser")
        elemip=soup.select('h3.text-center > a:nth-child(2)')
        ip = elemip[0].getText()
        elemco = soup.select('body > div.container.main-container > div > div.col-md-8.main-index > table > tbody > tr:nth-child(4) > td:nth-child(2) > span')
        country = elemco[0].getText()
        text = 'Bot ip Address = ' + ip +'\nCountry = '+ country
        return text
    except Exception as e:
        return "Something Went Wrong " + str(e)

@Error_decorator
def Class_Log_to_Excel(file, wtext = True):
    fin = open(file, encoding='UTF-8')
    doc=fin.readlines()
    data = dict()
    lst = ['%','!','L']
    
    for line in doc:
        try:
            text = line.split(':')[-1].strip()
            name = line.split(':')[1].split(']')[1]
            if not any(lst in name for lst in lst):
                minute = line.split(':')[1].split(']')[0]
                hour = line.split(':')[0].split('[')[1]
                a = datetime.datetime.now()
                tm = datetime.datetime(year=a.year, month=a.month, day=a.day, hour = int(hour), minute =int(minute))
                if name in data:
                    data[name]['Number of Response'] += 1
                    data[name]['Last_Comment'] = tm
                    data[name]['Texts'] = data[name]['Texts'] + '***' + text
                else:
                    data[name]= dict()
                    data[name]['First_Comment'] = tm
                    data[name]['Number of Response'] = 1
                    data[name]['Last_Comment'] = tm
                    data[name]['Texts'] = text
        except:
            pass
    
    a = datetime.datetime.now()
    command_time = lambda x: datetime.datetime(year=a.year, month=a.month, day=a.day, hour = int(doc[x].split(':')[0].split('[')[1]), minute =int(doc[x].split(':')[1].split(']')[0]))
    data['Total'] = dict()
    data['Total']['Number of Response'] = len(doc)-2
    data['Total']['First_Comment'] = command_time(2)
    data['Total']['Last_Comment'] = command_time(-1)
    data['Total']['Texts'] = "***************"
    fin.close()
    for name in data:
        data[name]['Duration'] = str(data[name]['Last_Comment'] - data[name]['First_Comment'])

    df = DataFrame(data)
    df = df.T
    df = df.fillna(0)
    if wtext == False:
        del df['Texts']
    filename = "{}.xlsx".format(os.path.splitext(file)[0])
    df.to_excel(filename)
    return filename

if __name__ == "__main__":
    print("Done !")